import java.util.Scanner;

/**
 * ArrayPlay - Experiments with simple arrays!
 *
 * Note: (un)comment the clone statement to see difference.
 *
 * @author David
 * @version 1.00 2012/12/3
 */

public class ArrayPlay
{
    public static void main( String[] args)
	{
    	Scanner scan = new Scanner( System.in);

    	System.out.println( "Start of ArrayPlay\n");

		// CONSTANTS

		// VARIABLES
		int[]	grades;
		int[]	results;

		int[] x = { 4, 3, 2, 1 };	// must declare & init at same time!

		String[] seasons = { "Spring", "Summer", "Autumn", "Winter"};

		// PROGRAM CODE

		// ***************************************************************
		// create grades array with 5 elements
		grades = new int[5];

		// ***************************************************************
		// can't just print out array object
		// System.out.println( grades);

		// ***************************************************************
		// must print element-by-element
		// (note initial default values--zero for numeric types)
		System.out.println( "Default values...");
		for ( int i : grades)
			System.out.print( i + "\t");
		System.out.println();

		// ***************************************************************
		// modify default values.
		grades[0] = 10;
		grades[1] = 25;
		grades[2] = grades[0] + grades[1];
		grades[3]++;

		// Run-time exception i invalid index
		// grades[-1] = 0;
		// grades[5] =  0;
		// grades[ grades.length] =  99;

		grades[ grades.length - 1 ] =  99;

		// ***************************************************************
		System.out.println();
		System.out.println( "Values after changes...");
		for ( int i : grades)
			System.out.print( i + "\t");
		System.out.println();

		// ***************************************************************
		results = grades;
		// results = grades.clone();

		grades[0] = 222;

		// ***************************************************************
		System.out.println();
		System.out.println( "Values after copy/clone...");
		System.out.println( "grades\tresults" );
		System.out.println( "---------------" );
		for ( int i = 0; i < 5; i++)
		{
			System.out.println( grades[i]
								+ "\t"
								+ results[i] );
		}
		System.out.println( "---------------" );
		System.out.println();

		// ***************************************************************
		System.out.println();
		System.out.println( "Values of (pre)initialised arrays x & seasons...");
		for ( int i = 0; i < x.length; i++)
		{
			System.out.println( x[i] + "\t" + seasons[i] );
		}
		System.out.println();

		// ***************************************************************
		System.out.println( "\nEnd of ArrayPlay\n" );
	}

} // end of class ArrayPlay
