import java.util.Scanner;

/**
 * EasyProblem - Basic solution to printing tables of differences from average
 *
 * @author David
 * @version 1.00 2012/12/3
 */

public class EasyProblem
{
    public static void main( String[] args)
	{
    	Scanner scan = new Scanner( System.in);

    	System.out.println( "Start of EasyProblem\n");

		// CONSTANTS
		// final int NO_OF_VALUES = 3;

		// VARIABLES
		int noOfValues;

		int[]	setOfValues;
		int		sum;
		double	average;

		// PROGRAM CODE

		// ***************************************************************
		// 1. read setOfValues
		// ***************************************************************
		System.out.print( "Enter no of values: ");
		noOfValues = scan.nextInt();

		setOfValues = new int[noOfValues];

		System.out.println( "Enter set of values: ");
		for ( int i = 0; i < setOfValues.length; i++)
		{
			setOfValues[i] = scan.nextInt();
		}
		System.out.println();


		// ***************************************************************
		// 2. compute average
		// ***************************************************************
		sum = 0;
		for ( int i = 0; i < setOfValues.length; i++)
		{
			sum = sum + setOfValues[i];
		}
		average = (double) sum / setOfValues.length;


		// ***************************************************************
		// 3. print table
		// ***************************************************************
		System.out.println( "Average = " + average);
		System.out.println();
		for ( int i = 0; i < setOfValues.length; i++)
		{
			System.out.println( setOfValues[i]
								+ "\t"
								+ (setOfValues[i] - average) );
		}


		System.out.println( "\nEnd of EasyProblem\n" );
	}

} // end of class EasyProblem
