import java.util.Scanner;

/**
 * EasyProblemUsingMethods2 - demo use of object parameters as outputs, not just inputs
 *		- readSetOfValues method changed to change values in existing input array
 *		- try uncommenting lines in computeAverage to see how things change/don't change!
 *		  Hint: try using the printArray method to see I/O values.
 *
 * Note: scan object moved to static class variable for use in both readSetOfValues & main.
 *
 * @author David
 * @version 1.00 2012/12/3
 */

public class EasyProblemUsingMethods2
{
   	static Scanner scan = new Scanner( System.in);

	// ***************************************************************
	// setOfValues has required number of elements,
	// 	just change their values to those entered by user.
	private static void readSetOfValues( int[] setOfValues)
	{
		System.out.println( "Enter set of values: ");
		for ( int i = 0; i < setOfValues.length; i++)
		{
			setOfValues[i] = scan.nextInt();
		}
		System.out.println();
	}

	// ***************************************************************
	// changes to values in tempValues reflect to actual parameter,
	// those to the reference don't.
	private static double computeAverage( int[] tempValues)
	{
		int		sum;
		double	average;

		sum = 0;
		for ( int i = 0; i < tempValues.length; i++)
		{
			sum = sum + tempValues[i];
			// tempValues[i] = 99;
		}
		average = (double) sum / tempValues.length;
		// tempValues = null;

		return average;
	}

	// ***************************************************************
	private static void printTable( double average,
									int[]  setOfValues)
	{
		System.out.println( "Average = " + average);
		System.out.println();
		for ( int i = 0; i < setOfValues.length; i++)
		{
			System.out.println( setOfValues[i]
								+ "\t"
								+ (setOfValues[i] - average) );
		}
	}


	// ***************************************************************
	private static void printArray( int[] values)
	{
		for ( int i : values)
			System.out.print( i + "\t");
		System.out.println();
	}


	// ***************************************************************
    public static void main( String[] args)
	{
    	System.out.println( "Start of EasyProblem2\n");

		int[]	setOfValues;
		double	average;

		int	noOfValues;

		// PROGRAM CODE

		// 1. read setOfValues
		System.out.print( "Enter no of values: ");
		noOfValues = scan.nextInt();

		setOfValues = new int[noOfValues];
		readSetOfValues( setOfValues);


		// 2. compute average using setOfValues
		average = computeAverage( setOfValues);


		// 3. print table of difference using average & setOfValues
		printTable( average, setOfValues);

		System.out.println( "\nEnd of EasyProblem2\n" );
	}

	// ***************************************************************
} // end of class EasyProblem2
